import { defineComponent as ae, ref as d, onMounted as J, withDirectives as le, createVNode as o, mergeProps as V, resolveComponent as w, resolveDirective as ie, unref as ne, nextTick as K, isVNode as ue, toRef as G, Fragment as oe } from "vue";
import re from "qs";
import "../../selectArea/index.js";
import "../../selectDate/index.js";
import "../../selectTime/index.js";
import "../../trend/index.js";
import "../../progress/index.js";
import "../../notification/index.js";
import "../index.js";
import { KCustomElement as p } from "../../customElement/index.js";
import "../../form/index.js";
import { tableProps as de, tableEmits as ce } from "./props.js";
import { Check as se, Close as me, Edit as ve } from "@element-plus/icons-vue";
import { createNamespacs as fe, getValue as A } from "@tomiaa/utils";
import "../../theme-chalk/lib/vue3-components/table.js";
import { useI18n as ge } from "vue-i18n";
function he(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !ue(e);
}
const T = fe("table"), Oe = ae({
  name: "KTable",
  props: de,
  emits: ce,
  setup(e, {
    attrs: D,
    slots: L,
    emit: v,
    expose: H
  }) {
    const {
      t: _
    } = ge(), R = d(""), I = d(""), {
      append: B,
      empty: W = () => e.emptyTip && P.value && R.value,
      page: X,
      editControlIcon: $,
      editIcon: N
    } = L, f = d({}), h = d({}), Y = (s) => s == null ? void 0 : s.map((m) => {
      const b = {};
      for (const t in m)
        b[t] = ne(m[t]);
      for (const t in m)
        if (typeof m[t] == "string" && /^(\$t\(|t\()/.test(m[t]) && /\)$/.test(m[t])) {
          let a = m[t].replace(/^(\$t\(|t\()/, "");
          a = a.replace(/\)$/, ""), a = a.replace(/(^'|^"|'$|"$)/g, ""), b[t] = _(a);
        }
      const {
        slot: x,
        action: y,
        actionConfig: l,
        editable: S,
        editableConfig: u,
        ...k
      } = b, i = {
        header: L.header,
        default: x && L[x]
      };
      if (e.editRow && (i.default = (t) => {
        const {
          row: a,
          column: c,
          $index: r
        } = t;
        return o("div", {
          class: [T.e("editable"), T.is("editable", f.value[r])]
        }, [f.value[r] ? o(w("el-input"), {
          size: "small",
          modelValue: h.value[r][c.property],
          "onUpdate:modelValue": (g) => h.value[r][c.property] = g
        }, null) : a[c.property]]);
      }), (y || l) && (i.default = (t) => {
        const {
          $index: a,
          row: c
        } = t;
        let r = [{
          el: "el-button",
          size: "small",
          "v-if": l == null ? void 0 : l.showEdit,
          onClick: () => {
            if (e.editRow) {
              if (f.value[a]) {
                Object.assign(t.row, h.value[a]), delete h.value[a], delete f.value[a], v("confirmEditRow", t);
                return;
              }
              h.value[a] = JSON.parse(JSON.stringify(c)), f.value[a] = !0;
            }
            v("edit", t);
          },
          children: f.value[a] ? "\u786E\u5B9A" : (l == null ? void 0 : l.editText) || "\u7F16\u8F91"
        }, {
          el: "el-button",
          size: "small",
          type: "danger",
          "v-if": l == null ? void 0 : l.showDelete,
          onClick: () => {
            if (e.editRow) {
              delete h.value[a], delete f.value[a], v("cancelEditRow", t);
              return;
            }
            v("delete", t);
          },
          children: f.value[a] ? "\u53D6\u6D88" : (l == null ? void 0 : l.deleteText) || "\u5220\u9664"
        }];
        return l != null && l.custom && (r = l.custom(r, t)), o(p, {
          list: r
        }, null);
      }), S || u) {
        const t = d({}), a = d({});
        i.default = (c) => {
          const {
            row: r,
            column: g,
            $index: ee
          } = c, n = g.id + ee, M = () => {
            delete a.value[n], delete t.value[n];
          };
          let O = [{
            el: "el-icon",
            color: "var(--el-color-success)",
            size: "1.2em",
            "v-if": u == null ? void 0 : u.showEnter,
            onClick() {
              r[g.property] = a.value[n], M(), v("confirmEditCell", c);
            },
            children: se
          }, {
            el: "el-icon",
            size: "1.2em",
            color: "var(--el-color-danger)",
            "v-if": u == null ? void 0 : u.showClose,
            onClick() {
              M(), v("cancelEditCell", c);
            },
            children: me
          }];
          return u != null && u.custom && (O = u.custom(O, c, G(t.value, n))), o("div", {
            class: [T.e("editable"), T.is("editable", t.value[n])]
          }, [t.value[n] ? o(w("el-input"), {
            size: "small",
            modelValue: a.value[n],
            "onUpdate:modelValue": (te) => a.value[n] = te
          }, null) : r[g.property], t.value[n] ? o(oe, null, [
            ($ == null ? void 0 : $({
              ...c,
              isEdit: G(t.value, n)
            })) || o(p, {
              list: O
            }, null)
          ]) : N ? o("span", {
            onClick: () => {
              a.value[n] = r[g.property];
            }
          }, [N({
            ...c,
            isEdit: G(t.value, n)
          })]) : o(w("el-icon"), {
            size: "1.2em",
            onClick: () => {
              a.value[n] = r[g.property], t.value[n] = !t.value[n];
            }
          }, {
            default: () => [o(ve, null, null)]
          })]);
        };
      }
      return o(w("el-table-column"), k, he(i) ? i : {
        default: () => [i]
      });
    }), Z = () => o(w("el-pagination"), V({
      class: T.b("pagination"),
      defaultCurrentPage: e.defaultCurrentPage,
      defaultPageSize: e.defaultPageSize,
      currentPage: q.value,
      pageSize: F.value,
      total: U.value,
      ref: z,
      layout: "->,sizes,prev,pager,next,jumper,total",
      "hide-on-single-page": !0
    }, D, {
      "onUpdate:currentPage": async (s) => {
        q.value = s, await K(), E();
      },
      "onUpdate:page-size": async (s) => {
        F.value = s, await K(), E();
      }
    }), {
      default: X
    }), z = d(), Q = d(), C = d(null), U = d(0), q = d(e.defaultCurrentPage || 1), F = d(e.defaultPageSize || 10), P = d(!1), E = () => {
      var S, u, k;
      P.value = !0, C.value = null;
      let s;
      e.emptyTip && (R.value = e.emptyTip, clearTimeout(s), s = setTimeout(() => {
        R.value = e.emptyTipTimeoutText;
      }, e.emptyTipTimeout));
      let m;
      e.elLoadingTextTimeoutText && (I.value = e.elementLoadingText, clearTimeout(m), setTimeout(() => {
        const i = document.querySelector(".el-loading-text");
        i && (i.innerHTML = e.elLoadingTextTimeoutText);
      }, e.elLoadingTextTimeout));
      const b = e.server, x = {
        [((S = e.replaceFields) == null ? void 0 : S.pageSize) || "pageSize"]: z.value.pageSize,
        [((u = e.replaceFields) == null ? void 0 : u.currentPage) || "currentPage"]: z.value.currentPage
      }, y = {};
      if (e.withDataPath !== !1) {
        const i = {
          get: "params",
          post: "data"
        }, t = e.withDataPath || i[(((k = e.getConfig) == null ? void 0 : k.method) || "get").toLocaleLowerCase()];
        t && (y[t] = {});
        const a = y[t] || y;
        Object.assign(a, e.withPagePath && typeof e.withPagePath == "string" ? {
          [e.withPagePath]: x
        } : x), Object.assign(a, e.withQueryPath && typeof e.withQueryPath == "string" ? {
          [e.withQueryPath]: e.withQuery
        } : e.withQuery);
      }
      const l = {
        url: e.getUrl,
        ...y,
        ...e.getConfig
      };
      e.stringify && l.data && (l.data = re.stringify(l.data)), v("beforeGetData", l), b(l).then((i) => {
        v("afterGetData", i), C.value = A(e.dataPath, i), U.value = A(e.totalPath, i);
      }).catch((i) => {
        v("failToGetData", i);
      }).finally(() => {
        clearTimeout(s), clearTimeout(m), P.value = !1;
      });
    };
    e.showPagination && J(E);
    const j = {
      getData: E
    };
    return J(() => {
      j.elPagination = z.value, j.elTable = Q.value;
    }), H(j), () => le(o("div", V({
      class: T.b(),
      "element-loading-text": I.value
    }, D), [o(w("el-table"), V({
      data: C.value,
      ref: Q
    }, D), {
      default: () => [Y(e.options)],
      append: B,
      empty: W
    }), e.showPagination && Z(), e.showLoadInGet && P.value]), [[ie("loading"), e.showLoadInGet && P.value]]);
  }
});
export {
  Oe as default
};
